﻿package implement

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/dao"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_model.git/utils/logx"
	"xorm.io/xorm"
)

type HappyOrchardUserAssistanceRecordsDb struct {
	Db *xorm.Engine
}

func (h HappyOrchardUserAssistanceRecordsDb) GetHappyOrchardUserAssistanceRecords(uid int, kind int32) (m *models.HappyOrchardUserAssistanceRecords, err error) {
	m = new(models.HappyOrchardUserAssistanceRecords)
	has, err := h.Db.Where("uid =?", uid).And("kind =?", kind).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (h HappyOrchardUserAssistanceRecordsDb) InsertHappyOrchardUserAssistanceRecords(m *models.HappyOrchardUserAssistanceRecords) (int, error) {
	_, err := h.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (h HappyOrchardUserAssistanceRecordsDb) UpdateHappyOrchardUserAssistanceRecords(m *models.HappyOrchardUserAssistanceRecords, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = h.Db.Where("id=?", m.Id).Cols(forceColums...).Update(m)
	} else {
		affected, err = h.Db.Where("id=?", m.Id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func NewHappyOrchardUserAssistanceRecordsDb(engine *xorm.Engine) dao.HappyOrchardUserAssistanceRecordsDao {
	return &HappyOrchardUserAssistanceRecordsDb{Db: engine}
}
