﻿package implement

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/dao"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_model.git/utils/logx"
	"xorm.io/xorm"
)

func NewSuperCloudIssuanceUserFreeRobotRecordsDb(engine *xorm.Engine, uid int) dao.SuperCloudIssuanceUserFreeRobotRecordsDao {
	return &SuperCloudIssuanceUserFreeRobotRecordsDb{Db: engine, Uid: uid}
}

type SuperCloudIssuanceUserFreeRobotRecordsDb struct {
	Db  *xorm.Engine `json:"model"`
	Uid int          `json:"uid"`
}

func (s SuperCloudIssuanceUserFreeRobotRecordsDb) GetCloudIssuanceUserFreeRobotRecord() (m *models.SuperCloudIssuanceUserFreeRobotRecords, err error) {
	m = new(models.SuperCloudIssuanceUserFreeRobotRecords)
	has, err := s.Db.Where("uid = ?", s.Uid).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (s SuperCloudIssuanceUserFreeRobotRecordsDb) GetCloudIssuanceUserFreeRobotRecordByRobotId(robotId int) (m *models.SuperCloudIssuanceUserFreeRobotRecords, err error) {
	m = new(models.SuperCloudIssuanceUserFreeRobotRecords)
	has, err := s.Db.Where("robot_id = ?", robotId).And("uid = ?", s.Uid).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (s SuperCloudIssuanceUserFreeRobotRecordsDb) InsertCloudIssuanceUserFreeRobotRecord(m *models.SuperCloudIssuanceUserFreeRobotRecords) (id int, err error) {
	_, err = s.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	id = m.Id
	return id, nil
}

func (s SuperCloudIssuanceUserFreeRobotRecordsDb) SaveCloudIssuanceUserFreeRobotRecord(id interface{}, m *models.SuperCloudIssuanceUserFreeRobotRecords, forceColums ...string) (affected int64, err error) {
	if forceColums != nil {
		affected, err = s.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = s.Db.Where("id=?", id).Update(m)
	}
	return
}
