package implement

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/dao"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_model.git/utils/logx"
	"xorm.io/xorm"
)

func NewSuperCloudIssuanceUserRobotBindFollowGroupDb(engine *xorm.Engine) dao.SuperCloudIssuanceUserRobotBindFollowGroupDao {
	return &SuperCloudIssuanceUserRobotBindFollowGroupDb{Db: engine}
}

type SuperCloudIssuanceUserRobotBindFollowGroupDb struct {
	Db *xorm.Engine
}

func (s SuperCloudIssuanceUserRobotBindFollowGroupDb) GetCloudIssuanceUserRobotBindFollowGroup(id int) (m *models.SuperCloudIssuanceUserRobotBindFollowGroup, err error) {
	m = new(models.SuperCloudIssuanceUserRobotBindFollowGroup)
	has, err := s.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (s SuperCloudIssuanceUserRobotBindFollowGroupDb) GetCloudIssuanceUserRobotBindFollowGroupByBindId(bandId int) (m []*models.SuperCloudIssuanceUserRobotBindFollowGroup, err error) {
	err = s.Db.Where("bind_id =?", bandId).Find(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	return m, nil
}

func (s SuperCloudIssuanceUserRobotBindFollowGroupDb) InsertCloudIssuanceUserRobotBindFollowGroup(m *models.SuperCloudIssuanceUserRobotBindFollowGroup) (id int, err error) {
	_, err = s.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	id = m.Id
	return id, nil
}

func (s SuperCloudIssuanceUserRobotBindFollowGroupDb) BatchAddCloudIssuanceUserRobotBindFollowGroups(data []*models.SuperCloudIssuanceUserRobotBindFollowGroup) (int64, error) {
	affected, err := s.Db.Insert(data)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (s SuperCloudIssuanceUserRobotBindFollowGroupDb) SaveCloudIssuanceUserRobotBindFollowGroup(id interface{}, m *models.SuperCloudIssuanceUserRobotBindFollowGroup, forceColums ...string) (affected int64, err error) {
	if forceColums != nil {
		affected, err = s.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = s.Db.Where("id=?", id).Update(m)
	}
	return
}

func (s SuperCloudIssuanceUserRobotBindFollowGroupDb) DeleteCloudIssuanceUserRobotBindFollowGroup(bindId interface{}) (affected int64, err error) {
	_, err = s.Db.Where("bind_id=?", bindId).Delete(models.SuperCloudIssuanceUserRobotBindFollowGroup{})
	if err != nil {
		return 0, err
	}
	return 1, nil
}
